<?php

class ConversationAPI {
    private $apiUrl = 'https://qianfan.baidubce.com/v2/app/conversation';
    private $bearerToken = 'Bearer bce-v3/ALTAK-GVWo90DYmQ2NVvu4Qbb003ae579d229'; // 替换为您的Bearer token
    private $logFile = 'conversation_log.txt'; // 日志文件名称

    // 创建新对话并获取对话ID
    public function createConversation() {
        $curl = curl_init();
        curl_setopt_array($curl, [
            CURLOPT_URL => $this->apiUrl,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => json_encode(['app_id' => 'c87d0af8-72dd70bd7714f']), // 替换为您的app_id
            CURLOPT_HTTPHEADER => [
                'X-Appbuilder-Authorization: ' . $this->bearerToken,
                'Content-Type: application/json'
            ],
        ]);
        $response = curl_exec($curl);
        curl_close($curl);
        return json_decode($response, true);
    }

    // 使用对话ID进行对话，并记录日志
    public function runConversation($conversationId, $query) {
        $payload = json_encode([
            'app_id' => 'c87d0af8-729bd7714f', // 替换为您的app_id
            'query' => $query,
            'stream' => false,
            'conversation_id' => $conversationId
        ]);
        $curl = curl_init();
        curl_setopt_array($curl, [
            CURLOPT_URL => $this->apiUrl . '/runs',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => $payload,
            CURLOPT_HTTPHEADER => [
                'X-Appbuilder-Authorization: ' . $this->bearerToken,
                'Content-Type: application/json'
            ],
        ]);
        $response = curl_exec($curl);
        curl_close($curl);
        $decodedResponse = json_decode($response, true);
        $answer = $decodedResponse['answer'] ?? 'No answer available';

        // 记录日志
        $this->log($query, $answer);

        return $decodedResponse;
    }

    // 记录日志到文件
    private function log($query, $answer) {
        $date = date('Y-m-d H:i:s');
        $logMessage = "$date ---- $query ---- $answer\n";
        file_put_contents($this->logFile, $logMessage, FILE_APPEND);
    }

    // API接口：接收外部请求并处理对话
    public function handleRequest() {
        $input = json_decode(file_get_contents('php://input'), true);
        $query = $input['query'];

        // 创建对话
        $createResponse = $this->createConversation();
        $conversationId = $createResponse['conversation_id'] ?? '';

        // 进行对话
        $runResponse = $this->runConversation($conversationId, $query);

        // 只返回对话结果中的 'answer' 部分
        header('Content-Type: text/plain; charset=UTF-8');
        echo $runResponse['answer'] ?? 'No answer available';
    }
}

$api = new ConversationAPI();
$api->handleRequest();

?>
